import { SpiritType } from "../enums";
import { ContainerSpirit } from "../spirit/base-container-spirit";
import { IOuputConfig, ISpiritConfig, ISpiritParams } from "../types/config";
import { DragLayout } from "../index";
import { Base } from "./base";
export declare class BaseSpirit extends Base {
    uid: number;
    sort: number;
    subSort: number;
    type: SpiritType;
    config: ISpiritConfig;
    background: string;
    private _active;
    resizableEl: HTMLDivElement;
    private _parentSpirit;
    line: number;
    offsetX: number;
    get parentSpirit(): ContainerSpirit;
    set parentSpirit(s: ContainerSpirit);
    get active(): boolean;
    set active(bool: boolean);
    get bottomPosition(): any;
    get rightPosition(): number;
    get centerLineX(): number;
    get centerLineY(): number;
    get style(): string;
    get clientWidth(): number;
    get clientHeight(): number;
    get parentWidth(): number;
    get ouputConfig(): IOuputConfig;
    get copySpirit(): import("../spirit/copy-spirit").CopySpirit;
    constructor(option: Partial<ISpiritParams>, dragLayout: DragLayout);
    calculatePercentageValue(val1: number, val2: number): number;
    initRender(): void;
    initResizableEl(): void;
    updateStyle(): void;
    handleResizable(event: MouseEvent): void;
    handleMousedown(event: MouseEvent): void;
    removeParentSpirit(): void;
    addParentSpirit(spirit: ContainerSpirit): void;
    setResizable(bool: boolean): void;
    getPosition(): {
        top: number;
        left: number;
    };
    destroy(): void;
}
