import { IConfig, IParams, ISpiritParams, IOuputConfig } from "./types/config";
import { Screen } from "./common/screen";
import { Panel } from "./utils/panel";
import "./less/index.less";
import { Spirit } from "./types";
import { Coordinates } from "./utils/coordinates";
import { MarkLine } from "./utils/markline";
import { ScrrenType, EditMode, SpiritType } from "./enums";
import { ContainerSpirit } from "./spirit";
declare class DragLayout {
    scrren: Screen;
    panel: Panel;
    spirits: Spirit[];
    coordinates: Coordinates;
    markLine: MarkLine;
    config: IConfig;
    private _activeSpirit;
    constructor(boxEle: HTMLDivElement, config?: Partial<IParams>);
    get activeSpirit(): Spirit;
    set activeSpirit(spirit: Spirit);
    get relativeSpirits(): Spirit[];
    get containerSpirits(): ContainerSpirit[];
    get firstHierarchySpirits(): Spirit[];
    get allSpiritCoordinates(): {
        x: number[];
        y: any[];
    };
    updateAllStyle(): void;
    addSpirit(option: Partial<ISpiritParams>): Spirit;
    getSpirit(uid: number | {
        x: number;
        y: number;
    }, arr?: Spirit[]): Spirit;
    setEditMode(mode: EditMode): void;
    setAdsorption(bool: boolean): void;
    getInfo<T = IOuputConfig>(): T[];
    loadSpirits(list: ISpiritParams[]): void;
    switchScrrenMode(type: ScrrenType): void;
}
export { DragLayout, ScrrenType, EditMode, SpiritType };
